/*
 * (C) 1992 SixxHeads Software
 * (C) 1992 Berkeley Systems Inc.
 * 
 * This code is freely distributable, but credit must be given in any
 * derivative work.
 * 
 * <Revision History>
 *		04/28/92 smz Created.
 */

#ifndef __PATCHES__
#define __PATCHES__

#include <GenericPatch.h>

class MenuSelectPatch : public GenericPatch {
public:
	MenuSelectPatch(void);
	virtual void Behavior(void);
};

typedef struct {
	Point			itsStartPt;
	unsigned long	itsResult;
} MenuSelectParameters;

typedef struct MenuSelectParameters ;
typedef pascal long (*MenuSelectProcPtr) (Point pt);

/***************************************************************************/

class HiliteMenuPatch : public GenericPatch {
public:
	HiliteMenuPatch(void);
	virtual void Behavior(void);
};

typedef pascal void (*HiliteMenuProcPtr)(short menuID);
typedef struct {
	short itsID;
	unsigned long dummy;
} HiliteMenuParms;

/***************************************************************************/

class SetCursorPatch : public GenericPatch {
public:
	SetCursorPatch(void);
	virtual void Behavior(void);
};

typedef struct {
	Cursor *itsCursorPtr;
	unsigned long dummy;
} SetCursorParameters;

/***************************************************************************/

class MenuKeyPatch : public GenericPatch {
public:
	MenuKeyPatch(void);
	virtual void Behavior(void);
};

typedef struct {
	char			padding;
	char			itsKey;
	unsigned long	itsResult;
} MenuKeyParameters;

typedef pascal long (*MenuKeyProcPtr)(short key);

/***************************************************************************/

class DrawMenuBarPatch : public GenericPatch {
public:
	DrawMenuBarPatch(void);
	virtual void Behavior(void);
};

typedef pascal void (*DrawMenuBarProcPtr)(void);

/***************************************************************************/

class SystemTaskPatch : public GenericPatch {
public:
	SystemTaskPatch(void);
	virtual void Behavior(void);
};

/***************************************************************************/

class FSDispatchPatch : public GenericPatch {
public:
	FSDispatchPatch(void);
	virtual void Behavior(void);
};

typedef pascal void (*FSDispatchProcPtr)(void);

/***************************************************************************/

class AlertPatch : public GenericPatch {
public:
	AlertPatch(void);
	virtual void Behavior(void);
};

typedef struct {
	long	itsProc;
	short	itsID;
	short	itsResult;
} AlertPatchParameters;

/***************************************************************************/
 
class NewWindowPatch : public GenericPatch {
public:
	NewWindowPatch(void);
	virtual void Behavior(void);
};

class NewCWindowPatch : public GenericPatch {
public:
	NewCWindowPatch(void);
	virtual void Behavior(void);
};

typedef struct {
	long		itsRefCon;
	Boolean		itsGoAwayFlag;
	WindowPtr	itsBehind;
	short		itsDefProc;
	Boolean		itsVisible;
	char 		*itsTitle;
	Rect		*itsBounds;
	Ptr			itsStorage;
	void		*itsResult;
} NewWindowParameters;

/***************************************************************************/

/* 
 * DrawString 
 */
class DrawStringPatch : public GenericPatch {
public:
	DrawStringPatch(void);
	virtual void Behavior(void);
};

typedef struct {
	unsigned char *itsString;
	unsigned long bogusResult;	/* for offsetOf */
} DrawStringParameters;

typedef pascal void (*DrawStringProcPtr)(Str255 s);

/***************************************************************************/
 
class StringWidthPatch : public GenericPatch {
public:
	StringWidthPatch(void);
	virtual void Behavior(void);
};

typedef struct {
	unsigned char *itsString;
	short itsResult;
} StringWidthParameters;

/***************************************************************************/

class InsertMenuPatch : public GenericPatch {
public:
	InsertMenuPatch(void);
	virtual void Behavior(void);
};

typedef struct {
	short			itsBeforeID;
	MenuHandle		itsMenuHandle;
	unsigned long 	dummy;	/* for offsetOf */
} InsertMenuParameters;

/***************************************************************************/

class DeleteMenuPatch : public GenericPatch {
public:
	DeleteMenuPatch(void);
	virtual void Behavior(void);
};

typedef struct {
	short			itsID;
	unsigned long 	dummy;	/* for offsetOf */
} DeleteMenuParameters;

/***************************************************************************/

class PostEventPatch : public GenericPatch {
public:
	PostEventPatch(void);
	void Behavior(void);
};

/***************************************************************************/

class ParamTextPatch : public GenericPatch {
public:
	ParamTextPatch(void);
	void Behavior(void);
};

typedef pascal void (*ParamTextProcPtr)(char *s1, char *s2, char *s3, char *s4);

typedef struct {
	char			*itsS1;
	char			*itsS2;
	char			*itsS3;
	char			*itsS4;
	unsigned long	 dummy;
} ParamTextParameters;

#endif __PATCHES__
