#pragma once

/*
 * (C) 1992 SixxHeads Software
 * All Rights Reserved
 *
 * Bits and pieces from around the world.
 * 
 * <Revision History>
 *		04/28/92 smz Created.
 */

#include <Processes.h>

#define reg				register

typedef struct {
	Boolean	itsDirKnown;
	short	itsVRefNum;
	long	itsDirID;
	short	itsRefNum;
	Boolean itsOpen;
	
	unsigned long	itsModDate;
	
	long	itsCreator;
	long	itsType;
	Str255	itsName;
} FileRecord;

typedef struct {
	MenuHandle	itsHandle;
	short		itsLeftEdge;
} PerMenu;

typedef struct {
	short	itemOffset;
	short	rightEdge;
	short	unused;
	PerMenu	permenu[];
} **MenuListHandle;

MenuListHandle theMenuList : 0xa1c;

/*
 * Debugging
 */
void dprintf(const char* format, ...);
void nprintf(const char* format, ...);

/* 
 * System Goodies
 */
Boolean IsFinderRunning(void);
Handle MoveToSystemHeap(Handle hRes);
Handle CopyToSystemHeap(Handle hMem);
Boolean HaveGestalt(void);
Boolean System7Running(void);
void SetMouse(Point newLoc);
void MemZero(void *pp, short l);

/* 
 * Graphics goodies
 */
void PlotSicn(Handle hSicn, short ix, Point loc);
void PushPort(GrafPtr pPort);
void PopPort(void);

/* 
 * ProcessManager goodies
 */
Boolean IsTargetRunning(long code, ProcessSerialNumber *r);
OSType GetProcessCreator(void);
OSType GetFrontProcessCreator(void);
void BringAppToFront(ProcessSerialNumber *p);

/*
 * String Goodies
 */
Boolean pstrequal(reg unsigned char *p1, reg unsigned char *p2);
void copystring(Str255 source, Str255 dest);
void cstring2pstring(unsigned char *cSource, Str255 dest);
Boolean pushstring(Str255 bssource, Str255 bsdest);
Boolean pushlong(long num, Str255 bsdest);
void pushchar(char c, Str255 s);
Boolean stringtotext(Str255 s, Handle *htext);
Boolean texttostring(Handle htext, Str255 s);
short String2Short(Str255 s);
Boolean String2Boolean(Str255 tmp);
void ellipsize(Str255 s, short width);
void centerstring(Rect r, Str255 s); 
void setfontsizestyle(short fontnum, short fontsize, short fontstyle);

/*
 * FSUtils
 */
void PushFullPath(CInfoPBPtr info, Handle **hFileList);
Handle GetFullPath(short vRefNum, unsigned long parentID, Str255 baseName);
Boolean NewFileRecord(Str255 s, long creator, long type, FileRecord* info);
Boolean OpenPrefsFile(FileRecord *info);
Boolean ClosePrefsFile(FileRecord* info);
OSErr CreatePrefsFile(FileRecord* info);
unsigned long GetFileModDate(FileRecord* info);
Boolean PrefsFileChanged(FileRecord* info);

/*
 * Menus
 */
Boolean IsItemEnabled(unsigned long theItem);
MenuHandle FindInstalledMenu(short menuID, short *leftEdge);